<?php
require_once("Logger.php");
require_once("exceptions/DbException.php");
/**
 * The Db class is representing the connection to the database.
 */
class Db {
	private static $instance = null;
	
	private $link = null;
	
	/**
	 * The constructor. The constructor is never called by anyone by a static
	 * method called getInstance() since this is class is implemented using the
	 * singleton design pattern.
	 * @throws DbException if the database connection could not be established
	 * or if the database could not be selected
	 */
	private function __construct() {
		Logger::write("Entering Db::__construct", 1);
		$this->link = mysql_connect(DB_HOST, DB_USER, DB_PASS);
		if(!$this->link)
			throw new DbException("Db::__construct", "Could not connect to database server\n". mysql_error()); 
		if(!mysql_select_db(DB_NAME, $this->link))
			throw new DbException("Db::__construct", "Could not select database\n". mysql_error()); 
	}
	
	public function __destruct() {
		Logger::write("Entering Db::__destruct", 1);
		$this->close();	
	}
	
	/**
	 * Query database.
	 * @param string $query the query statement
	 * @return resource the result of the query 
	 * @throws DbException if the query failed
	 */
	public function query($query) {
		Logger::write("Entering Db::query($query)", 1);
		$result = mysql_query($query, $this->link);
		if(!$result)
			throw new DbException("Db::query", "Querying the database failed\nQuery: ". $query);
		return $result;
	}
	
	/**
	 * Insert a row into database.
	 * @param string $query the insert statement
	 * @throws DbException if the insert failed
	 */
	public function insert($query) {
		Logger::write("Entering Db::insert", 1);
		if(!mysql_query($query, $this->link))
			throw new DbException("Db::insert", "Insert into the database failed\nQuery: ". $query);
	}
		
	/**
	 * Insert a row into database and get the row created by the insert in a
	 * result set.
	 * @param string $query the insert statement
	 * @param string $table the table to insert into
	 * @return resource a result set containing the row created by the insert
	 * @throws DbException if the insert failed or if the row cannot be queried
	 */
	public function insertQueryLast($query, $table) {
		Logger::write("Entering Db::insertQueryLast", 1);
		$this->insert($query);
		$lastId = mysql_insert_id($this->link);
		$query = "SELECT * FROM $table WHERE id = $lastId";
		$result = mysql_query($query, $this->link);
		if(!$result)
			throw new DbException("Db::insertQueryLast", "Could not get last record with id = '". $lastId. "' from ".$table);
		return $result;	
	}
	
	/**
	 * Update database.
	 * @param string $query the update statement
	 * @throws DbException if the update fails
	 */
	public function update($query) {
		Logger::write("Entering Db::update", 1);
		if(!mysql_query($query, $this->link))
			throw new DbException("Db::update", "Could not update database\n\tQuery: ". $query);
	}		
	
	/**
	 * Fetch the next row in the result set index by numbers
	 * @return array the next row as an indexed array
	 */
	public function fetchRow($result) {
		return mysql_fetch_row($result);
	}
	
	/**
	 * Fetch the next row in the result set as an associative array
	 * @return array the next row as an associative array
	 */
	public function fetchAssoc($result) {
		return mysql_fetch_assoc($result);
	} 
	
	/**
	 * Get the number of rows in the given result set
	 * @param resource $result the result set to be examined
	 */
	public function numRows($result) {
		return mysql_num_rows($result);
	}
	
	/**
	 * Close database connection
	 */
	public function close() {
		Logger::write("Entering Db::close", 1);
		if($this->link != null) {
			mysql_close($this->link);
			$this->link = null;
		}	
	}

	/**
	 * Get the instance of the database connection
	 * @return Db the instance of the database connection
	 * @throws DbException if the connection to the database server or the
	 * selection of database fails
	 */	
	public static function getInstance() {
		Logger::write("Entering Db::getInstance", 1);
		if(Db::$instance == null) {
			Db::$instance = new Db();
		}
		return Db::$instance;
	}
}
?>
