<?php
/**
 * The UniqueId class is used for inserting and checking unique ids in the
 * database.
 */
class UniqueId {
	
	/**
	 * Check if an id is unique
	 * @param integer $id the id to check
	 * @throws DbException if the id could not be checked towards the database
	 */
	public static function isUnique($id) {
		Logger::write("Entering UniqueId::isUnique", 1);
		$dbconn = Db::getInstance();
		$query = "SELECT count(uniqid) FROM uniqid WHERE uniqid = '$id' AND date > NOW()";
		$result = $dbconn->query($query);
		$line = $dbconn->fetchRow($result);
		return(!(bool) $line[0]);
	}
	
	/**
	 * Insert a new unique id in the database
	 * @param string $id the id to insert into the database
	 * @throws DbException if the id could not be inserted into the database
	 */
	public static function setUnique($id) {
		Logger::write("Entering UniqueId::setUnique", 1);
		$dbconn = Db::getInstance();
		$query = "INSERT INTO uniqid (uniqid, date) VALUES ('$id', DATE_ADD(NOW(), INTERVAL 1 DAY))";
		$dbconn->insert($query);
	}
	
	/**
	 * Delete obsolete ids from the database
	 * @throws DbException if deleting the obsolete ids from the database fails.
	 */
	public static function deleteObsoleteIds() {
		Logger::write("Entering UniqueId::deleteObsoleteIds", 1);
 		$dbconn = Db::getInstance();
 		$query = "DELETE FROM uniqid WHERE date < NOW()";
 		$dbconn->update($query);
	}
}
?>
