<?
/**
 * Exception to be thrown when an operation fails. 
 */
class GalleryException extends Exception {
	
	private $location = '';
	
	/**
	 * Constructor
	 * @param string $location where in the code the exception occurred
	 * @param string $message the exception message
	 * exception (optional)
	 */
	public function __construct($location, $message) {
		$this->location = $location;
		parent::__construct($message);
	}
	
	/**
	 * Get the location in the code where the exception occurred
	 * @return string the location in the code where the exception occurred
	 */
	public function getLocation() {
		return $this->location;
	}
}