<?php
require_once("settings/settings.php");
require_once("classes/DbImage.php");

$imageid = $_GET["imageid"];

try {
	$dbimage = DbImage::getDbImage($imageid);
} catch(Exception $e) {
	@session_start();
	$_SESSION["errormessage"] = $e->getMessage();
	header("Location: error.php");
}
?>	
<html>
	<head>
		<title>EXIF info for <?= $dbimage->getName() ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<link href="themes/<?= THEME ?>/css/gallery.css" rel="stylesheet" type="text/css" />
		<!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
	</head>
	<body>
		<div class="centered">
			<table class="exiftable">
				<tr>
					<td class="imageheading" colspan="2">EXIF Headers - <?= $dbimage->getName() ?></td>
				</tr>
<?
if($exif = @exif_read_data(IMAGES_PATH.DIRECTORY_SEPARATOR.$dbimage->getFileName(), 'EXIF', true)) {
	foreach ($exif as $key => $section) {
?>
				<tr>
					<td class="imageinfo center divider" colspan="2"><?= $key ?></td>
				</tr>
<?
  		foreach ($section as $name => $val) {
			if($name != "MakerNote" && substr_count($name, 'UndefinedTag') == 0) {
?>
				<tr>
					<td class="imageinfo"><?= $name ?></td>
					<td class="imageinfo"><?= $val ?></td>
				</tr>
<?
			}
		}
?>
				<tr>
					<td class="divider" colspan="2"></td>
				</tr>
<?
   	}
} else {
?>
				<tr>
					<td class="imageinfo" colspan="2">No EXIF headers found</td>
				</tr>
<?
}
?>
			</table>
		</div>
	</body>
</html>
