<?php
require_once("settings/settings.php");

require_once("classes/Action.php");
require_once("classes/Access.php");
require_once("classes/DbImage.php");
require_once("classes/DbGallery.php");
require_once("classes/DbUser.php");
	
session_start();
	
$actionobj = null;
$dbgalleries = null;
$dbimages = null;
$dbuser = null;
$isprivate = false;
$isadmin = false;
$galleryid = $_REQUEST["galleryid"];
$dbgallery = null;
$lastvisit = "0000-00-00";

try {
	if($_REQUEST["login"])
		new Access($_REQUEST["login"]);
	
	$actionobj = new Action();
	
	$dbuser = Access::getCurrentUser();
	if($dbuser != null) {
		$isprivate = $dbuser->isPrivate();
		$isadmin = $dbuser->isAdmin();
	}
	
	$dbgalleries = DbGallery::getAllDbGalleries($isprivate || $isadmin);

	if((!isset($galleryid) || $galleryid == '') && count($dbgalleries) != 0) {
		$galleryid = $dbgalleries[count($dbgalleries) - 1]->getGalleryId();
	}
	if(isset($galleryid) && $galleryid != '') {
		$dbgallery = DbGallery::getDbGallery($galleryid);
		$dbimages = DbImage::getAllDbImages($galleryid, ((bool)$isprivate || (bool)$isadmin));
	}

} catch(GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	$erruri = "gallery.php";
	include("error.php");
	exit;
}
?>
<html>
	<head>
		<title><?= GALLERY_TITLE.((bool)$dbgallery?" - ".$dbgallery->getName():"") ?></title>
		<link href="themes/<?= THEME ?>/css/gallery.css" rel="stylesheet" type="text/css" />
		<!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<script type="text/javascript">
function openwindow(id) {
	window.open("exif.php?imageid="+id,"my_new_window","toolbar=no, location=no, directories=no, status=no, menubar=yes, scrollbars=yes, resizable=yes, copyhistory=no, width=600, height=500")
}
		</script>
	</head>
	<body>
	<div class="centered">
		<table class="maintable">
   			<tr>
				<td class="maintabletop" colspan="2">
					<table class="pagetitle">
						<tr>
							<td class="gallerytitle"><?= GALLERY_TITLE ?></td>
						</tr>
						<tr>
							<td class="galleryname"><?= $dbgallery!=null?$dbgallery->getName():"&nbsp;" ?></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="maintablemenu">
					<table class="galleriesmenu">
						<tr>
							<td class="menuheading">Galleries</td>
						</tr>
<?
foreach($dbgalleries as $dbg) {
?>
						<tr>
							<td class="menuitem">
								<a href="imageadmin.php?galleryid=<?= $dbg->getGalleryId() ?>">&raquo;</a>
 								<a href="gallery.php?galleryid=<?= $dbg->getGalleryId() ?>">
<?
	$gname = $dbg->getName();
	if($dbg->isPrivate())
		$gname = "<I>".$gname."</i>";
	if($dbg->getGalleryId() == $galleryid)
		$gname = "<strong>".$gname."</strong>";
	echo("$gname");
?>
								</a>
							</td>
						</tr>
<? 
} 
?>
						<tr><td class="divider"></td></tr>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php">View toplist</a>
							</td>
						</tr>
					</table>
					<br />
					<table class="alternativesmenu">
						<tr>
							<td class="menuheading"><?= Alternatives ?></td>
						</tr>
						<tr>
							<td class="menuitem">
								&raquo; <a href="<?= MAIN_PAGE_URL ?>"><?= MAIN_PAGE_NAME ?></a>
							</td>
						</tr>
<?
if($_SESSION["showimageinfo"]) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="gallery.php?action=image_info_hide&galleryid=<?= $galleryid ?>">Hide image info</a>
							</td>
						</tr>
<? 
} else {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="gallery.php?action=image_info_show&galleryid=<?= $galleryid ?>">Show image info</a>
							</td>
						</tr>
<?
}
if($dbuser) {
	if($isadmin) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="galleryadmin.php">Goto admin</a>
							</td>
						</tr>
<?
	}
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="gallery.php?action=user_logout&galleryid=<?= $galleryid ?>">Logout <? $dbuser->getUsername() ?></a>
							</td>
						</tr>
<?
} else {
?>
						<tr>
							<td class="menuitem divider">
								&raquo; <a href="useradd.php">Register new user</a>
							</td>
						</tr>
<?
}
?>
					</table>
					<br />
					<form name="form2" method="post" action="gallery.php?login=user">
						<table class="usersmenu">
							<tr>
  		   						<td class="menuheading" colspan="2">Login</td>
							</tr>
<?
if($dbuser != null) {
?>
							<tr>
								<td class="menuitem center divider" colspan="2">Current user: <?= $dbuser->getUsername() ?></td>
							</tr>
<?
} 
?>
							<tr>
								<td class="menuitem">Username:</td>
							    <td class="menuitem"><input name="username" type="text" size="10" class="text" /></td>
							</tr>
							<tr>
								<td class="menuitem divider">Password:</td>
								<td class="menuitem divider"><input name="password" type="password" size="10" class="text" /></td>
							</tr>
							<tr>
								<td colspan="2" class="menuitem center"><input type="submit" name="Submit" value="Login" /></td>
							</tr>
						</table>
					</form>
				</td>
				<td class="maintablebody">
					<table>
<?
if(!$dbimages) {
?>
						<tr>
							<td class="emptygallery">Gallery is empty</td>
						</tr>
<?
} else {
	$rows = ceil(count($dbimages) / THUMBS_COLUMNS);
	for($i=0; $i<$rows; $i++) {
?>
						<tr>
<?				
		for($j=0; $j<THUMBS_COLUMNS; $j++) {
			if(($i * THUMBS_COLUMNS + $j) >= count($dbimages))
				break;
			$dbimage = $dbimages[$i*THUMBS_COLUMNS+$j];
?>
							<td class="thumbholder"">
   							<a name="<?= $dbimage->getImageId() ?>"></a>
								<table class="thumb">
									<tr>
  				   						<td class="imageheading" colspan="2">
<?php 
			if($dbimage->isPrivate())
				echo("<I>".strtolower($dbimage->getDate())."</i>");
			else
				echo(strtolower($dbimage->getDate())); 
?>
										</td>
									</tr>
<?php
			if($_SESSION["showimageinfo"]) {
				$imageinfo = getimagesize(IMAGES_PATH.DIRECTORY_SEPARATOR.$dbimage->getFileName());
?>
									<tr>
										<td class="thumbinfo">Name:</td>
										<td class="thumbinfo"><?= $dbimage->getName() ?></td>
									</tr>
									<tr>
										<td class="thumbinfo">Width:</td>
										<td class="thumbinfo"><?= $imageinfo[0] ?> pixels</td>
									</tr>
									<tr>
										<td class="thumbinfo">Height:</td>
										<td class="thumbinfo"><?= $imageinfo[1] ?> pixels</td>
									</tr>
									<tr>
										<td class="thumbinfo divider">Viewed:</td>
										<td class="thumbinfo divider"><?= $dbimage->getHits() ?> time<?= $dbimage->getHits()==1?"":"s" ?></td>
									</tr>
<? 
				if(function_exists(exif_read_data)) { ?>
									<tr>
										<td class="thumbinfo center divider" colspan="2"><a href="Javascript:openwindow(<?= $dbimage->getImageId() ?>)">EXIF info</a></td>
									</tr>
<?				
				} 
			}
?>
									<tr>
										<td class="thumbimage" colspan="2">
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=<?= $dbimage->getDefaultSize() ?>">
												<img src="<?= GALLERY_DIR.DIRECTORY_SEPARATOR.THUMBS_DIR.DIRECTORY_SEPARATOR.$dbimage->getFileName() ?>" border="0" alt="<?= $dbimage->getName() ?>" title="<?= $dbimage->getName() ?>" />
											</a>
										</td>
									</tr>
<?
			if($dbimage->getComment()) { 
?>
									<tr>
										<td class="thumbinfo divider" colspan="2">
<?= $dbimage->getComment() ?>									
										</td>
									</tr>
<?
			}
?>
									<tr>
										<td class="thumbinfo center" colspan="2">
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=100">100%</a> |
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=50">50%</a> |
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=25">25%</a>
										</td>
									</tr>
								</table>
							</td>
<?
		}
?>				
						</tr>
<?
	}
}
?>
					</table>
				</td>
			</tr>
		</table>
	</div>
</body>
</html>
