<?php
require_once("settings/settings.php");
require_once("classes/Access.php");
require_once("classes/Action.php");
require_once("classes/DbUser.php");
require_once("classes/DbGallery.php");

session_start();

$actionobj = null;
$dbgalleries = null;

try {
	new Access("admin");
	$actionobj = new Action();
	$dbgalleries = DbGallery::getAllDbGalleries(true);
} catch(GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	$erruri = "galleryadmin.php";
	include("error.php");
	exit;	
}
?>
<html>
	<head>
		<title>Gallery administration</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<link href="themes/<?= THEME ?>/css/admin.css" rel="stylesheet" type="text/css" />
	</head>
	<body>
		<div class="centered">
			<table class="maintable">
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Administrate Galleries</td>
							</tr>
							<tr>
								<td class="subadmintitle">
[<a href="useradmin.php">User admin</a>]&nbsp;&nbsp;
[<a href="gallery.php">Gallery</a>]&nbsp;&nbsp; 
[<a href="<?= MAIN_PAGE_URL ?>"><?= MAIN_PAGE_NAME ?></a>]
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="maintablebody">
						<form name="form1" method="post" action="galleryadmin.php">
							<input name="action" id="action" value="gallery_add" type="hidden" />
							<input name="uniqueid" id="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Add gallery</td>
								</tr>
								<tr>
									<td class="actionitem">Name:</td>
									<td class="actionitem">
										<input name="galleryname" type="text" id="galleryname" />
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">Private:</td>
									<td class="actionitem divider">
										<select name="isprivate" id="isprivate">
											<option value="1">Yes</option>
											<option value="0" selected>No</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit" value="Add" />
									</td>
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="form2" method="post" action="galleryadmin.php">
							<input name="action" id="action" value="gallery_remove" type="hidden" />
							<input name="uniqueid" id="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Remove gallery</td>
								</tr>
								<tr>
									<td class="actionitem divider">Gallery:</td>
									<td class="actionitem divider">
										<select name="galleryid" id="galleryid">
											<option value="" selected="selected">&laquo; Select gallery &raquo;</option>
<?php
	foreach($dbgalleries as $dbgallery) {
		echo("<OPTION value=\"".$dbgallery->getGalleryId()."\">".$dbgallery->getName()."</option>\n");
	}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit" value="Remove" />
									</td>
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="editgalleryform" method="get" action="imageadmin.php">
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Administrate gallery</td>
								</tr>
								<tr>
									<td class="actionitem divider">Gallery:</td>
									<td class="actionitem divider">
										<select name="galleryid" id="galleryid">
											<option value="" selected="selected">&laquo; Select gallery &raquo;</option>
<?php
	foreach($dbgalleries as $dbgallery) {
		echo("<OPTION value=\"".$dbgallery->getGalleryId()."\">".$dbgallery->getName()."</option>\n");
	}
?>
										</select>
									</td>
								</tr>
								<tr align="center">
									<td class="actionitem" colspan="2">
										<input type="submit" value="Administrate" />
									</td>
								</tr>
							</table>
						</form>
					</td>
				</tr>
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Status</td>
							</tr>
							<tr>
								<td class="<?= $actionobj->getStatus()?"textok":"texterror" ?>">
<?= $actionobj->getMessage() ?>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>