<?php
require_once("settings/settings.php");
require_once("classes/Access.php");
require_once("classes/Action.php");
require_once("classes/DbImage.php");
require_once("classes/DbGallery.php");
	
session_start();

$actionobj = null;
$dbimages = null;
$dbgalleries = null;	
$dbgallery = null;
$galleryid = $_GET["galleryid"];
$actionuri = "imageadmin.php?galleryid=$galleryid";

if(!isset($galleryid)) {
	$erruri = "galleryadmin.php";
	$errmsg = "No gallery selected";
	include("error.php");
	exit();
}

try {
	new Access("admin");

	$actionobj = new Action();

	$dbgallery = DbGallery::getDbGallery($galleryid); 
	$dbimages = DbImage::getAllDbImages($galleryid, true);
	$dbgalleries = DbGallery::getAllDbGalleries(true);

} catch(GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	$erruri = "imageadmin.php?galleryid=$galleryid";
	include("error.php");
	exit;
}
?>
<html>
	<head>
		<title>Image admin</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<link href="themes/<?= THEME ?>/css/admin.css" rel="stylesheet" type="text/css" />
		<!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
		<script type="text/javascript">
function setForm(id) {
	if(id != "") {
		setComment(id);
		setPrivacy(id);
		setImage(id);
		setDefaultSize(id);
		setRotation(id);
		setDate(id);
	}
}	

function setDefaultSize(id) {
	var defaultSize = "";
	var index = 1;
	
	switch(id) {
<?
foreach($dbimages as $dbimage) {	
?>
		case "<?= $dbimage->getImageId() ?>" :
			defaultSize = defaultSize + "<?= $dbimage->getDefaultSize() ?>";
			break;
<?
}
?>
	}
	switch(defaultSize) {
		case "100":
			index = 0;
			break;
		case "50":
			index = 1;
			break;
		case "25":
			index = 2;
	}
	document.getElementById("editimagedefaultsize").options[index].selected = true	
}

function setRotation(id) {
	var rotation = "";
	var index = 1;
	
	switch(id) {
<?
foreach($dbimages as $dbimage) {	
?>
		case "<?= $dbimage->getImageId() ?>" :
			rotation = rotation + "<?= $dbimage->getRotation() ?>";
			break;
<?
}
?>
	}
	switch(rotation) {
		case "90":
			index = 1;
			break;
		case "180":
			index = 2;
			break;
		case "270":
			index = 3;
			break;
		case "0":
		default:
			index = 0;
	}
	document.getElementById("editimagerotation").options[index].selected = true	
}

function setComment(id) {
	if(id != 0) {
		document.getElementById("editimagecomment").value=document.getElementById("comment"+id).value;
	}
}

function setPrivacy(id) {
	var isPrivate = 0;

	switch(id) {
<?
foreach($dbimages as $dbimage) {
?>
		case "<?= $dbimage->getImageId() ?>" :
				isPrivate = isPrivate + <?= $dbimage->isPrivate()?1:0 ?>;
				break;
<?
}
?>
	}
	document.getElementById("editimageisprivate").options[isPrivate].selected = true;
}

function setImage(id) {
	var imgSrc = "";
	
	switch(id) {
<?
foreach($dbimages as $dbimage) {
?>
		case "<?= $dbimage->getImageId() ?>" :
			imgSrc = imgSrc + "<?= GALLERY_DIR.DIRECTORY_SEPARATOR.THUMBS_DIR.DIRECTORY_SEPARATOR.$dbimage->getFileName() ?>";
			break;
<?
}
?>
		default:
			imgSrc = imgSrc + "themes/<?= THEME ?>/pics/dummy.gif";
	}
	document.imageHolder.src = imgSrc;
}

function setDate(id) {
	var date = "";
	switch(id) {
<?
foreach($dbimages as $dbimage) {
?>
		case "<?= $dbimage->getImageId() ?>" :
			date = date + "<?= $dbimage->getDate() ?>";
			break;
<?
}
?>
	}
	document.getElementById("editimagedate").value = date;
}
		</script>
	</head>
	<body>
		<div class="centered">
			<table class="maintable">
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Administrate Gallery: <?= $dbgallery->getName() ?></td>
							</tr>
							<tr>
								<td class="subadmintitle">
[<a href="galleryadmin.php">Gallery admin</a>]&nbsp;&nbsp; 
[<a href="useradmin.php">User admin</a>]&nbsp;&nbsp;
[<a href="gallery.php?galleryid=<?= $galleryid ?>">Gallery</a>]&nbsp;&nbsp; 
[<a href="<?= MAIN_PAGE_URL ?>"><?= MAIN_PAGE_NAME ?></a>]</td>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="maintablebody">
						<form action="<?= $actionuri ?>" method="post" enctype="multipart/form-data" name="form4">
							<input name="action" value="image_add" type="hidden" />
							<input name="uniqueid" type="hidden" value="<?= uniqid("") ?>" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Add image</td>
								</tr>
								<tr>
									<td class="actionitem">Image:</td>
									<td class="actionitem">
										<input type="file" name="file" id="file" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">Comment:</td>
									<td class="actionitem">
										<textarea name="comment" cols="20" rows="3"></textarea>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Private:</td>
									<td class="actionitem">
										<select name="isprivate">
											<option value="0" selected>No</option>
											<option value="1">Yes</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Default size:</td>
									<td class="actionitem">
										<select name="defaultsize">
											<option value="100">100%</option>
											<option value="50">50%</option>
											<option value="25" selected="selected">25%</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">Rotation:</td>
									<td class="actionitem divider">
										<select name="rotation">
											<option value="0" selected>none</option>
											<option value="90">90 degrees CCW</option>
											<option value="180">180 degrees CCW</option>
											<option value="270">90 degrees CW</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit4" value="Add" />
									</td>
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<table class="actiongroup">
							<tr>
								<td class="actionheading">Preview</td>
							</tr>
							<tr>
								<td class="actionitem center"><img src="themes/<?= THEME ?>/pics/dummy.gif" border="0" name="imageHolder" id="imageHolder"></td>
							</tr>
						</table>
					</td>
					<td class="maintablebody">
						<form action="<?= $actionuri ?>" method="post" name="editImageForm" id="editImageForm">
							<input name="action" value="image_edit" type="hidden" />
							<input name="uniqueid" type="hidden" value="<?= uniqid("") ?>" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Image properties</td>
								</tr>
								<tr>
									<td class="actionitem">Image:</td>
									<td class="actionitem">
										<select name="imageid" id="imageid" onChange="setForm(this.options[this.selectedIndex].value)">
											<option value="0" selected>&laquo; Select image &raquo;</option>
<?php
foreach($dbimages as $dbimage) {
?>
											<option value="<?= $dbimage->getImageId() ?>"><?= $dbimage->getName() ?></option>
<?
}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Comment:</td>
									<td class="actionitem">
										<textarea name="comment" cols="20" rows="3" id="editimagecomment"></textarea>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Private:</td>
									<td class="actionitem">
										<select name="isprivate" id="editimageisprivate">
											<option value="0" selected>No</option>
											<option value="1">Yes</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Default size:</td>
									<td class="actionitem">
										<select name="defaultsize" id="editimagedefaultsize">
											<option value="100">100%</option>
											<option value="50" selected>50%</option>
											<option value="25">25%</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Rotation:</td>
									<td class="actionitem">
										<select name="rotation" id="editimagerotation">
											<option value="0" selected>none</option>
											<option value="90">90 degrees CCW</option>
											<option value="180">180 degrees CCW</option>
											<option value="270">90 degrees CW</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">Date:</td>
									<td class="actionitem divider">
										<input type="text" name="date" id="editimagedate" />
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit9" value="Change" />
									</td>
								</tr>
							</table>
						</form>
					</td>
				</tr>
				<tr>
					<td class="maintablebody">
						<form name="form5" method="post" action="<?= $actionuri ?>">
							<input name="action" value="image_remove" type="hidden" />
							<input name="uniqueid" type="hidden" value="<?= uniqid("") ?>" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Remove image</td>
								</tr>
								<tr>
									<td class="actionitem divider">Image:</td>
									<td class="actionitem divider">
										<select name="imageid" id="imageid" onChange="setImage(this.options[this.selectedIndex].value)">
											<option value="" selected>&laquo; Select image &raquo;</option>
<?
foreach($dbimages as $dbimage) {
?>
											<option value="<?= $dbimage->getImageId() ?>"><?= $dbimage->getName() ?></option>
<?
}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit5" value="Remove" />
									</td>
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="form6" method="post" action="<?= $actionuri ?>">
							<input name="action" value="image_move" type="hidden" />
							<input name="uniqueid" type="hidden" value="<?= uniqid("") ?>" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Move image</td>
								</tr>
								<tr>
									<td class="actionitem">Image:</td>
									<td class="actionitem">
										<select name="imageid" id="imageid" onChange="setImage(this.options[this.selectedIndex].value)">
											<option value="" selected>&laquo; Select image &raquo;</option>
<?
foreach($dbimages as $dbimage) {
?>
											<option value="<?= $dbimage->getImageId() ?>"><?= $dbimage->getName() ?></option>
<?
}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">To gallery:</td>
									<td class="actionitem divider">
										<select name="togalleryid">
<?
foreach($dbgalleries as $dbg) {
	if($dbg->getGalleryId() != $galleryid) {
?>
											<option value="<?= $dbg->getGalleryId() ?>"><?= $dbg->getName() ?></option>
<?
	}
}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit6" value="Move" />
									</td>
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="form3" method="post" action="<?= $actionuri ?>">
							<input name="action" value="gallery_edit" type="hidden" />
							<input name="uniqueid" type="hidden" id="uniqid" value="<?= uniqid("") ?>" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Gallery properties</td>
								</tr>
								<tr>
									<td class="actionitem">New name:</td>
									<td class="actionitem">
										<input name="galleryname" type="text" value="<?= $dbgallery->getName() ?>"/>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Private:</td>
									<td class="actionitem">
										<select name="isprivate">
											<option value="1"<?= $dbgallery->isPrivate()?" selected":"" ?>>Yes</option>
											<option value="0"<?= !$dbgallery->isPrivate()?" selected":"" ?>>No</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">New name:</td>
									<td class="actionitem divider">
										<input name="gallerydate" type="text" value="<?= $dbgallery->getDate() ?>"/>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit3" value="Change" />
									</td>
								</tr>
							</table>
						</form>
					</td>
				</tr>
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Status</td>
							</tr>
							<tr>
								<td class="<?= $actionobj->getStatus()?"textok":"texterror" ?>" align="center">
<?= $actionobj->getMessage() ?>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</div>
<?
foreach($dbimages as $dbimage) {
?>
		<textarea id="comment<?= $dbimage->getImageId() ?>" name="comment<?= $dbimage->getImageId() ?>" class="invisible"><?= $dbimage->getComment() ?></textarea>
<?
}
?>		
	</body>
</html>
