<?
require_once("settings/settings.php");
require_once("classes/Db.php");

$status = "<ul>\n";
$flag = false;
	
if(isset($_REQUEST["setup"])) {
	try {
		$dbconn = Db::getInstance();
		
		/* Create user table */
		$query = <<<QUERY
CREATE TABLE users (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  password varchar(100) NOT NULL default '',
  is_private tinyint(3) unsigned NOT NULL default '0',
  email varchar(60) default NULL,
  peer varchar(15) default NULL,
  is_admin tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM
QUERY;
		$dbconn->insert($query);
		$status .= "<li class=\"textok\">\"users\" table created</li>\n";
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create table \"users\"</li>\n";
		$flag = true;
	}
		
	try {
		/* Insert admin into users table */
		if(isset($_REQUEST["username"]) && isset($_REQUEST["password"])) {
			$username = $_REQUEST["username"];
			$password = $_REQUEST["password"];
			$email = $_REQUEST["email"];
			$query = "INSERT INTO users (name, password, is_private, email, peer, is_admin) ".
					 "VALUES ('$username', '$password', 1, '$email', '', 1)";
			$dbconn->insert($query);
			$status .= "<li class=\"textok\">Administrative user \"$username\" created</li>\n";
		}
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create administrative user \"$username\"</li>\n";
		$flag = true;
	}
		
	try {
		/* Create table galleries */
		$query = <<<QUERY
CREATE TABLE galleries (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  date date NOT NULL default '0000-00-00',
  is_private tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (id)
) TYPE=MyISAM
QUERY;
		$dbconn->insert($query);
		$status .= "<li class=\"textok\">\"galleries\" table created</li>\n";
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create table \"galleries\"</li>\n";
		$flag = true;
	}
		
	try {
		/* Create table images */
		$query = <<<QUERY
CREATE TABLE images (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  gallery_id int(11) NOT NULL default '0',
  date date NOT NULL default '0000-00-00',
  comment varchar(255) NOT NULL default '',
  is_private tinyint(1) NOT NULL default '0',
  hits int(11) NOT NULL default '0',
  default_size int(10) unsigned NOT NULL default '50',
  filename varchar(45) NOT NULL default '',
  rotation int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
QUERY;
		$dbconn->insert($query);
		$status .= "<li class=\"textok\">\"images\" table created</li>\n";
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create table \"images\"</li>\n";
		$flag = true;
	}
		
	try {
		/* Create table uniqid */
		$query = <<<QUERY
CREATE TABLE uniqid (
  id int(11) NOT NULL auto_increment,
  uniqid varchar(100) NOT NULL default '',
  date date NOT NULL default '0000-00-00',
  PRIMARY KEY  (id)
) TYPE=MyISAM
QUERY;
		$dbconn->insert($query);
		$status .= "<li class=\"textok\">\"uniqid\" table created</li>\n";
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create table \"uniqid\"</li>\n";
		$flag = true;
	}
		
	try {
		/* Create table comments */	
		$query = <<<QUERY
CREATE TABLE comments (
  id int(10) unsigned NOT NULL auto_increment,
  user_id int(10) unsigned NOT NULL default '0',
  comment text NOT NULL,
  date datetime NOT NULL default '0000-00-00 00:00:00',
  peer varchar(15) NOT NULL default '',
  image_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM
QUERY;
		$dbconn->insert($query);
		$status .= "<li class=\"textok\">\"comments\" table created</li>\n";
	} catch(GalleryException $ge) {
		$status .= "<li class=\"texterror\">Could not create table \"comments\"</li>\n";
		$flag = true;
	}
		
	if(!file_exists(GALLERY_ROOT_DIR)) {
		if(!mkdir(GALLERY_ROOT_DIR)) {
			$status .= "<li class=\"texterror\">Could not create directory \"".GALLERY_ROOT_DIR."\"</li>\n";
			$flag = true;
		} else
			$status .= "<li class=\"textok\">\"".GALLERY_ROOT_DIR."\" directory created</li>\n";
	}
	
	if(!file_exists(IMAGES_PATH)) {
		if(!mkdir(IMAGES_PATH)) {
			$status .= "<li class=\"texterror\">Could not create directory \"".IMAGES_PATH."\"</li>\n";
			$flag = true;
		} else
			$status .= "<li class=\"textok\">\"".IMAGES_PATH."\" directory created</li>\n";
	}	

	if(!file_exists(THUMBS_PATH)) {
		if(!mkdir(THUMBS_PATH)) {
			$status .= "<li class=\"texterror\">Could not create directory \"".THUMBS_PATH."\"</li>\n";
			$flag = true;
		} else
			$status .= "<li class=\"textok\">\"".THUMBS_PATH."\" directory created</li>\n";
	}	
	$status .= "</ul>\n";
}
?>
<html>
	<head>
		<title>Setup gallery</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<link href="themes/<?= THEME ?>/css/admin.css" rel="stylesheet" type="text/css" />
		<!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
	</head>
	<body>
		<div class="centered">
			<table class="maintable">
				<tr>
					<td class="maintablebody">
						<form name="form1" method="post" action="setup.php">
							<input name="setup" type="hidden" value="setup">
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Setup gallery database</td>
								</tr>
<?
if(!isset($_REQUEST["setup"])) {
?>
								<tr>
									<td class="actionitem">Admin username:</td>
									<td class="actionitem"><input name="username" type="text" class="text" /></td>
								</tr>
								<tr>
									<td class="actionitem">Admin password:</td>
									<td class="actionitem"><input name="password" type="password" class="text" /></td>
								</tr>
								<tr>
									<td class="actionitem divider">Admin e-mail:</td>
									<td class="actionitem divider"><input name="email" type="text" class="text" /></td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2"><input name="Submit" type="submit" value="Submit" class="text"></td>
								</tr>
<?
} else {
?>
								<tr>
									<td class="actionitem divider" colspan="2">
<?= $status ?>
									</td>
								</tr>
								<tr>
<?
	if($flag) {
?>
									<td class="actionitem texterror" colspan="2">
Something went wrong during setup. Please review the message above and the log file
									</td>
<?
	} else {
?>
									<td class="actionitem textok center">
Galleries setup was successful. 
									</td>
									<td class="actionitem center">
Go to <a href="gallery.php">gallery.php</a> to start using the gallery.
									</td>
									<td class="actionitem center"> 
Don't forget to delete this file (setup.php) or move it to a safe location.
									</td>
<?
	}
?>
								</tr>
<?
}
?>
							</table>
						</form>
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>
