<?php
require_once("settings/settings.php");
require_once("classes/Action.php");
require_once("classes/Access.php");
require_once("classes/DbUser.php");
require_once("classes/DbComment.php");
require_once("classes/DbImage.php");

$isprivate = false;
$toplist = false;
$toplistnr = 0;
try {
	new Action();

	$imageid = $_REQUEST["imageid"];
	$size = $_REQUEST["size"];
	if(isset($_REQUEST["toplist"])) {
		$toplist = true;
		$toplistnr = $_REQUEST["toplist"];
	}

	$dbuser = Access::getCurrentUser();
	if($dbuser != null)
		$isprivate = $dbuser->isPrivate();
	
	$dbimage = DbImage::getDbImage($imageid);
	if(!$toplist)
		$dbimage->incHits();
	$imagename = $dbimage->getDate();
	$galleryid = $dbimage->getGalleryId();
	
	$filename = $dbimage->getFilename();
	
	$previous = "&nbsp;";
	$next = "&nbsp;";

	if($toplist) {
		$prevdbimage = DbImage::getToplistDbImage($toplistnr - 1, $isprivate);
		if($prevdbimage)
			$previous = "<A href='show.php?imageid=".$prevdbimage->getImageId()."&size=".$prevdbimage->getDefaultSize()."&toplist=".($toplistnr-1)."'>Previous</a> |\n";
		$nextdbimage = DbImage::getToplistDbImage($toplistnr + 1, $isprivate);
		if($nextdbimage)
			$next = "| <a href='show.php?imageid=".$nextdbimage->getImageId()."&size=".$nextdbimage->getDefaultSize()."&toplist=".($toplistnr+1)."'>Next</a>\n";
	} else {		
		$prevdbimage = $dbimage->getPreviousDbImage($isprivate);
		if($prevdbimage)
			$previous = "<A href='show.php?imageid=".$prevdbimage->getImageId()."&size=".$prevdbimage->getDefaultSize()."'>Previous</a> |\n";
		$nextdbimage = $dbimage->getNextDbImage($isprivate);
		if($nextdbimage)
			$next = "| <a href='show.php?imageid=".$nextdbimage->getImageId()."&size=".$nextdbimage->getDefaultSize()."'>Next</a>\n";
	}
} catch (GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	if($toplist)
		$erruri = "toplist.php";
	else
		$erruri = "gallery.php?galleryid=$galleryid";
	include("error.php");
	exit;
}
?>	
<html>
	<head>
		<title><?= $dbimage->getDate() ?></title>
	  <link href="themes/<?= THEME ?>/css/gallery.css" rel="stylesheet" type="text/css" />
	  <!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	</head>
	<body>
		<div class="centered">
			<table class="showimage" id="show">
				<tr>
					<td class="imageheading"><?= $dbimage->getDate() ?></td>
				</tr>
				<tr>
					<td class="imageinfo center divider">
						<img src="outputimage.php?size=<?= $size ?>&imageid=<?= $imageid ?>" alt="<?= $dbimage->getName() ?>" title="<?= $dbimage->getName() ?>" />
					</td>
				</tr>
<?
if($dbimage->getComment() != '') {
?>
				<tr>
					<td class="imageinfo center divider">
<?= $dbimage->getComment() ?>					
					</td>
				</tr>
<?
}
?>
				<tr>
					<td class="imageinfo center divider">
						<?= $previous ?>
<?
if($toplist) {
?>
						<a href="toplist.php#<?= $imageid ?>">Back to toplist</a>
<?
} else {
?>
						<a href="gallery.php?galleryid=<?= $galleryid ?>#<?= $imageid ?>">Back to gallery</a>
<?
}
?>
						<?= $next ?>
					</td>
				</tr>
<?
if($toplist) {
?>
				<tr>
					<td class="imageinfo center divider">
					Toplist # <?= $toplistnr ?> - Viewed <?= $dbimage->getHits() ?> time<?= $dbimage->getHits()!=1?"s":"" ?>
					</td>
				</tr>
				<tr>
					<td class="imageinfo center">
						<a href="show.php?imageid=<?= $imageid ?>&size=100&toplist=<?= $toplistnr ?>">100%</a> |
						<a href="show.php?imageid=<?= $imageid ?>&size=50&toplist=<?= $toplistnr ?>">50%</a> |
						<a href="show.php?imageid=<?= $imageid ?>&size=25&toplist=<?= $toplistnr ?>">25%</a>
					</td>
				</tr>
<?
} else {
?>
				<tr>
					<td class="imageinfo center">
						<a href="show.php?imageid=<?= $imageid ?>&size=100">100%</a> |
						<a href="show.php?imageid=<?= $imageid ?>&size=50">50%</a> |
						<a href="show.php?imageid=<?= $imageid ?>&size=25">25%</a>
					</td>
				</tr>
<?
}
?>
			</table>
<?
$dbcomments = DbComment::getAllDbComments($imageid);
$currentuser = Access::getCurrentUser();
if(count($dbcomments) > 0) {
?>
			<br />
			<form action="show.php?imageid=<?= $imageid ?>&size=<?= $size ?>" method="post">
				<input name="action" value="comment_remove" type="hidden" />
				<input name="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
				<table class="commenttable">
					<tr>
						<td class="imageheading" colspan="3">Comments</td>
					</tr>
<?
	foreach($dbcomments as $dbcomment) {
		$dbuser = DbUser::getDbUser($dbcomment->getUserId());
?>	
					<tr>
<?
		if($currentuser != null && ($currentuser->getUserId == $dbcomment->getUserId || $currentuser->isAdmin())) {
?>
						<td class="imageinfo"><input type="checkbox" name="commentid" value="<?= $dbcomment->getCommentId() ?>" /></td>
<?
		} else {
?>
						<td>&nbsp;</td>
<?
		}
?>
						<td class="imageinfo max"><b><?= $dbuser->getUsername() ?></b></td>
						<td class="imageinfo right" nowrap="nowrap"><i><?= $dbcomment->getDate() ?></i></td>  
					</tr>
					<tr>
						<td class="imageinfo divider" colspan="3"><?= $dbcomment->getComment() ?></td>
					</tr>
<?
	}
	if($currentuser != null && ($currentuser->getUserId() == $dbcomment->getUserId() || $currentuser->isAdmin())) {
?>
					<tr>
						<td colspan="3" class="imageinfo center"><input type="submit" name="Submit5" value="Remove selected" /></td>
					</tr>
<?
	}
?>
				</table>
			</form>
<?
}
if($currentuser != null) {
?>
			<br />
			<form method="post" action="show.php?imageid=<?= $imageid ?>&size=<?= $size ?>">
				<input name="action" type="hidden" value="comment_add" />
				<input name="userid" type="hidden" value="<?= $currentuser->getUserId() ?>" />
				<input name="uniqueid" type="hidden" value="<?= uniqid("") ?>" />
				<table class="commenttable">
					<tr>
						<td class="imageheading">Add comment</td>
					</tr>
					<tr>
						<td class="imageinfo">Comment:</td>
					</tr>
					<tr>
						<td class="imageinfo divider">
							<textarea name="comment" cols="70" rows="10"></textarea>
						</td>
					</tr>
					<tr>
						<td class="imageinfo center">
							<input type="submit" name="Submit4" value="Add" />
						</td>
					</tr>
				</table>
			</form>
<?
}
?>
		</div>
	</body>
</html>
