<?php
require_once("settings/settings.php");

require_once("classes/Action.php");
require_once("classes/Access.php");
require_once("classes/DbImage.php");
require_once("classes/DbGallery.php");
require_once("classes/DbUser.php");
	
session_start();
	
$actionobj = null;
$dbimages = null;
$dbuser = null;
$isprivate = false;
$isadmin = false;
$page = 1;

try {
	if($_REQUEST["login"])
		new Access($_REQUEST["login"]);
	
	$actionobj = new Action();
	
	$dbuser = Access::getCurrentUser();
	if($dbuser != null) {
		$isprivate = $dbuser->isPrivate();
		$isadmin = $dbuser->isAdmin();
	}
	
	if(isset($_REQUEST["page"]))
		$page = $_REQUEST["page"];
	
	$dbimages = DbImage::getToplistDbImages($page, $isprivate);

} catch(GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	$erruri = "toplist.php?page=".$page;
	include("error.php");
	exit;
}
?>
<html>
	<head>
		<title><?= GALLERY_TITLE ?> - Toplist</title>
		<link href="themes/<?= THEME ?>/css/gallery.css" rel="stylesheet" type="text/css" />
		<!-- <LINK href="themes/original/css/gallery.css" rel="stylesheet" type="text/css" /> -->
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<script type="text/javascript">
function openwindow(id) {
	window.open("exif.php?imageid="+id,"my_new_window","toolbar=no, location=no, directories=no, status=no, menubar=yes, scrollbars=yes, resizable=yes, copyhistory=no, width=500, height=500")
}
		</script>
	</head>
	<body>
	<div class="centered">
		<table class="maintable">
   			<tr>
				<td class="maintabletop" colspan="2">
					<table class="pagetitle">
						<tr>
							<td class="gallerytitle"><?= GALLERY_TITLE ?></td>
						</tr>
						<tr>
							<td class="galleryname">Toplist - page <?= $page ?></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="maintablemenu">
					<table class="galleriesmenu">
						<tr>
							<td class="menuheading">Toplist</td>
						</tr>
<?
if($page > 1) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php?page=<?= $page - 1 ?>">Previous page (<?= $page - 1 ?>)</a>
							</td>
						</tr>
<? 
} 
if(count($dbimages) > TOPLIST_NUMBER) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php?page=<?= $page + 1 ?>">Next page (<?= $page + 1 ?>)</a>
							</td>
						</tr>
<?
}
?>
					</table>
					<br />
					<table class="alternativesmenu">
						<tr>
							<td class="menuheading"><?= Alternatives ?></td>
						</tr>
						<tr>
							<td class="menuitem">
								&raquo; <a href="<?= MAIN_PAGE_URL ?>"><?= MAIN_PAGE_NAME ?></a>
							</td>
						</tr>
						<tr>
							<td class="menuitem">
								&raquo; <a href="gallery.php">Back to gallery</a>
							</td>
						</tr>
<?
if($_SESSION["showimageinfo"]) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php?action=image_info_hide&page=<?= $page ?>">Hide image info</a>
							</td>
						</tr>
<? 
} else {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php?action=image_info_show&page=<?= $page ?>">Show image info</a>
							</td>
						</tr>
<?
}
if($dbuser) {
	if($isadmin) {
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="galleryadmin.php">Goto admin</a>
							</td>
						</tr>
<?
	}
?>
						<tr>
							<td class="menuitem">
								&raquo; <a href="toplist.php?action=user_logout&page=<?= $page ?>">Logout <? $dbuser->getUsername() ?></a>
							</td>
						</tr>
<?
} else {
?>
						<tr>
							<td class="menuitem divider">
								&raquo; <a href="useradd.php">Register new user</a>
							</td>
						</tr>
<?
}
?>
					</table>
					<br />
					<form name="form2" method="post" action="toplist.php?login=user&page=<?= $page ?>">
						<table class="usersmenu">
							<tr>
  		   						<td class="menuheading" colspan="2">Login</td>
							</tr>
<?
if($dbuser != null) {
?>
							<tr>
								<td class="menuitem center divider" colspan="2">Current user: <?= $dbuser->getUsername() ?></td>
							</tr>
<?
} 
?>
							<tr>
								<td class="menuitem">Username:</td>
							    <td class="menuitem"><input name="username" type="text" size="10" class="text" /></td>
							</tr>
							<tr>
								<td class="menuitem divider">Password:</td>
								<td class="menuitem divider"><input name="password" type="password" size="10" class="text" /></td>
							</tr>
							<tr>
								<td colspan="2" class="menuitem center"><input type="submit" name="Submit" value="Login" /></td>
							</tr>
						</table>
					</form>
				</td>
				<td class="maintablebody">
					<table>
<?
if(!$dbimages) {
?>
						<tr>
							<td class="emptygallery">No images</td>
						</tr>
<?
} else {
	if(count($dbimages) > TOPLIST_NUMBER)
		$imgcount = TOPLIST_NUMBER;
	else
		$imgcount = count($dbimages);
	$rows = ceil($imgcount / THUMBS_COLUMNS);
	for($i=0; $i<$rows; $i++) {
?>
						<tr>
<?				
		for($j=0; $j<THUMBS_COLUMNS; $j++) {
			if(($i * THUMBS_COLUMNS + $j) >= $imgcount)
				break;
			$toplistnr = $i*THUMBS_COLUMNS+$j+1+($page-1)*TOPLIST_NUMBER;
			$dbimage = $dbimages[$i*THUMBS_COLUMNS+$j];
			$dbgallery = DbGallery::getDbGallery($dbimage->getGalleryId());
?>
							<td class="thumbholder"">
								<a name="<?= $dbimage->getImageId() ?>"></a>
								<table class="thumb">
									<tr>
										<td class="imageheading" colspan="2">
<? 
			if($dbimage->isPrivate())
				echo("<I>".strtolower($dbimage->getName())."</i>");
			else
				echo(strtolower($dbimage->getName())); 
?>
										</td>
									</tr>
<?
			if($_SESSION["showimageinfo"]) {
				$imageinfo = getimagesize(IMAGES_PATH.DIRECTORY_SEPARATOR.$dbimage->getFileName());
?>
									<tr>
										<td class="thumbinfo">Date:</td>
										<td class="thumbinfo"><?= $dbimage->getDate() ?></td>
									</tr>
									<tr>
										<td class="thumbinfo">Width:</td>
										<td class="thumbinfo"><?= $imageinfo[0] ?> pixels</td>
									</tr>
									<tr>
										<td class="thumbinfo divider">Height:</td>
										<td class="thumbinfo divider"><?= $imageinfo[1] ?> pixels</td>
									</tr>
<? 
				if(function_exists(exif_read_data)) { ?>
									<tr>
										<td class="thumbinfo center divider" colspan="2"><a href="Javascript:openwindow(<?= $dbimage->getImageId() ?>)">EXIF info</a></td>
									</tr>
<?				
				} 
			}
?>
									<tr>
										<td class="thumbimage" colspan="2">
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=<?= $dbimage->getDefaultSize() ?>&toplist=<?= $toplistnr ?>">
												<img src="<?= GALLERY_DIR.DIRECTORY_SEPARATOR.THUMBS_DIR.DIRECTORY_SEPARATOR.$dbimage->getFileName() ?>" border="0">
											</a>
										</td>
									</tr>
<?
			if($dbimage->getComment()) { 
?>
									<tr>
										<td class="thumbinfo divider" colspan="2">
<?= $dbimage->getComment() ?>									
										</td>
									</tr>
<?
			}
?>
									<tr>
										<td class="thumbinfo center" colspan="2">
Viewed <?= $dbimage->getHits() ?> time<?= ($dbimage->getHits() != 1)?"s":"" ?>
										</td>
									</tr>										
									<tr>
										<td class="thumbinfo center divider" colspan="2">
Gallery: <a href="gallery.php?galleryid=<?= $dbimage->getGalleryId() ?>"><?= $dbgallery->getName() ?></a>
										</td>
									</tr>										
									<tr>
										<td class="thumbinfo center" colspan="2">
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=100&toplist=<?= $toplistnr ?>">100%</a> |
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=50&toplist=<?= $toplistnr ?>">50%</a> |
											<a href="show.php?imageid=<?= $dbimage->getImageId() ?>&size=25&toplist=<?= $toplistnr ?>">25%</a>
										</td>
									</tr>
								</table>
							</td>
<?
		}
?>				
						</tr>
<?
	}
}
?>
					</table>
				</td>
			</tr>
		</table>
	</div>
</body>
</html>
