<?php
require_once("settings/settings.php");
require_once("classes/Access.php");
require_once("classes/Action.php");
require_once("classes/DbUser.php");
require_once("classes/DbImage.php");
require_once("classes/DbGallery.php");

session_start();

$actionObj = null;
$dbusers = null;

try {
	new Access("admin");
	$actionObj = new Action();
	$dbusers = DbUser::getAllDbUsers();
} catch(GalleryException $ge) {
	$errmsg = $ge->getMessage();
	$errdet = $ge->getTraceAsString();
	$erruri = "useradmin.php";
	include("error.php");
	exit;
}	

?>
<html>
	<head>
		<title>Gallery administration</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<link href="themes/<?= THEME ?>/css/admin.css" rel="stylesheet" type="text/css" />
		<script type="text/javascript">
function setForm(id) {
	var email = "";
	var priv = 0;
	var admin = 0;
	if(id != "") {
		switch(id) {
<?
	foreach($dbusers as $dbuser) {
?>
			case "<?= $dbuser->getUserId() ?>" :
				email = email + "<?= $dbuser->getEmail() ?>"; 
				priv = priv + <?= (bool)$dbuser->isPrivate()?"1":"0" ?>;
				admin = admin + <?= (bool)$dbuser->isAdmin()?"1":"0" ?>; 
				break;
<?php
	}
?>
		}
	}
	document.getElementById("edituseremail").value = email;
	document.getElementById("edituserisprivate").options[priv].selected = true;
	document.getElementById("edituserisadmin").options[admin].selected = true;
}
		</script>
	</head>
	<body>
		<div class="centered">
			<table class="maintable">
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Administrate Users</td>
							</tr>
							<tr>
								<td class="subadmintitle">
[<a href="galleryadmin.php">Gallery admin</a>]&nbsp;&nbsp; 
[<a href="gallery.php">Gallery</a>]&nbsp;&nbsp; 
[<a href="<?= MAIN_PAGE_URL ?>"><?= MAIN_PAGE_NAME ?></a>]
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="maintablebody">
						<form name="form7" method="post" action="useradmin.php">
							<input name="action" id="action" value="user_add" type="hidden" />
							<input name="uniqueid" id="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Add user</td>
								</tr>
								<tr>
									<td class="actionitem">Name:</td>
									<td class="actionitem">
										<input name="username" type="text" id="adduserusername" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">Password:</td>
									<td class="actionitem">
										<input type="password" name="password" id="adduserpassword" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">E-mail:</td>
									<td class="actionitem">
										<input type="text" name="email" id="adduseremail" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">Private:</td>
									<td class="actionitem">
										<select id="adduserisprivate" name="isprivate">
											<option value="1">Yes</option>
											<option value="0" selected="selected">No</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">Administrator:</td>
									<td class="actionitem divider">
										<select name="isadmin">
											<option value="1">Yes</option>
											<option value="0" selected="selected">No</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit7" value="Add" />
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="form8" method="post" action="useradmin.php">
							<input name="action" id="action" value="user_remove" type="hidden" />
							<input name="uniqueid" id="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Remove user</td>
								</tr>
								<tr>
									<td class="actionitem divider">User:</td>
									<td class="actionitem divider">
										<select name="userid" id="userid">
											<option value="" selected="selected">&laquo; Select user &raquo;</option>
<?
	foreach($dbusers as $dbuser)
		echo("<OPTION value=\"".$dbuser->getUserId()."\">".$dbuser->getUsername()."</option>\n");
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit7" value="Remove" />
								</tr>
							</table>
						</form>
					</td>
					<td class="maintablebody">
						<form name="edituserform" id="edituserform" method="post" action="useradmin.php">
							<input name="action" id="action" value="user_edit" type="hidden" />
							<input name="uniqueid" id="uniqueid" value="<?= uniqid("") ?>" type="hidden" />
							<table class="actiongroup">
								<tr>
									<td class="actionheading" colspan="2">Edit user</td>
								</tr>
								<tr>
									<td class="actionitem">User:</td>
									<td class="actionitem">
										<select id="userid" name="userid" onChange="setForm(this.options[this.selectedIndex].value)">
											<option value="" selected="selected">&laquo; Select user &raquo;</option>
<?php
	foreach($dbusers as $dbuser)
		echo("<OPTION value=\"".$dbuser->getUserId()."\">".$dbuser->getUsername()."</option>\n");
?>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem">Old password:</td>
									<td class="actionitem">
										<input type="password" id="oldpassword" name="oldpassword" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">New password:</td>
									<td class="actionitem">
										<input type="password" id="newpassword" name="newpassword" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">E-mail:</td>
									<td class="actionitem">
										<input type="text" id="edituseremail" name="email" />
									</td>
								</tr>
								<tr>
									<td class="actionitem">Private:</td>
									<td class="actionitem">
										<select id="edituserisprivate" name="isprivate">
											<option value="0" selected="selected">No</option>
											<option value="1">Yes</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem divider">Administrator:</td>
									<td class="actionitem divider">
										<select id="edituserisadmin" name="isadmin">
											<option value="0" selected="selected">No</option>
											<option value="1">Yes</option>
										</select>
									</td>
								</tr>
								<tr>
									<td class="actionitem center" colspan="2">
										<input type="submit" name="Submit7" value="Change" />
								</tr>
							</table>
						</form>
					</td>
				</tr>
				<tr>
					<td class="maintabletop" colspan="3">
						<table class="pagetitle">
							<tr>
								<td class="admintitle">Status</td>
							</tr>
							<tr>
								<td class="<?= $actionObj->getStatus()?"textok":"texterror" ?>" align="center">
<?= $actionObj->getMessage() ?>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</div>
	</body>
</html>